
// Las clases del paquete GP
   import GP.*;

/**
 * Evalua la capacidad de un individuo para aproximar
 * la funcion f(x) = x^3.<BR>
 *
 * @author Antonio Pena
 * @version jul-1997
 */
   public class Cubica extends GP.Entrenador { 

   // El numero de casos a evaluar
      static int casos = 20 ;

   // Estas son las jugadas elegidas para esta poblacion
      private static float[] seleccion = new float[ casos ];



   /**
    * Este metodo se ejecuta al iniciar la evaluacion de
    * una poblacion.<BR>
    *
    * Fija los casos a probar para cada individuo.<BR> */
      public static void init() {

      // Llena los casos para la poblacion
         for (int i=0; i<casos; i++)
            seleccion[ i ] = (float) Math.random( ) * 100;
      }


   /**
    * Averigua que tan bueno es este individuo para aproximar la cubica.<BR> */
      private float fd( Individuo el_bueno ) {
         float         x, valor;
         float         calif = 0;

         for (int i=0; i<casos; i++) {

         // La calificacion es la suma de los errores del chamaco
            x = seleccion[ i ];
            valor = ((floatAtom)el_bueno.getRPB().getRaiz()).eval( el_bueno,
                                                  (Object) new Float( x ));
            float real = (float) (2 * Math.pow( x, 3 ) + 0.25);
            calif += Math.abs( real - valor );
         }

         return calif;
      }


   // Devuelve la adecuacion ajustada de el_bueno
      public float[] fitness() {

      // El individuo a evaluar
         Individuo ind = cobayos[ 0 ];
         float[] calif = new float[ 0 ];

      
      // Evalua al chamaco
         float error_total = fd( ind );
         ind.setFa( 1f / ( 1 + error_total ) );

         return calif;

      }
   }


