
// Parte del paquete de GP
   package GP;

/**
 * De la clase <B>Entrenador</B> deben derivarse las funciones de
 * evaluacion para individuos de la poblacion.<BR>
 *
 * @author Antonio Pena
 * @version jun-1997
 */
   public abstract class Entrenador implements Runnable {

   /**
    * El arreglo de individuos a evaluar.<BR> */
      protected Individuo[] cobayos;



   /**
    * Un constructor vacio.<BR> */
      public Entrenador() { }


   /**
    * Devuelve el arreglo de individuos a evaluar.<BR> */
      public Individuo[] getCobayos() { return cobayos; }


   /**
    * Fija el arreglo de individuos a evaluar.<BR>
    *
    * @param conejillos
    *    Es un arreglo de individuos a evaluar.<BR> */
      public void setCobayos( Individuo[] conejos ) { cobayos = conejos; }


   /**
    * Se ejecuta sobre el entrenador cada vez que se inicia una nueva
    * poblacion.<BR> */
      public void startPobEval( Poblacion pob ) { }


   /**
    * El metodo <B>fitness</B> debe evaluar al grupo de individuos.<BR>
    *
    * @return Un arreglo de <B>float</B> con las calificaciones
    *         de los individuos evaluados.<BR>
    *
    *         En forma especial, el entrenador puede devolver
    *         un arreglo vacio, en cuyo caso, es su responsabilidad
    *         fijar la calificacion de los individuos utilizando
    *         el metodo <B>setFa</B>.<BR> */
      public abstract float[] fitness();


   /**
    * El metodo <B>run</B> de la interfaz <B>Runnable</B> para
    * poder crear threads de evaluacion.<BR> */
      public void run() {

      // El arreglo que recibe las calificaciones de los individuos
         float[]  calif;

      // Obten la calificacion de los individuos
         calif = fitness();

      // Asigna las calificaciones
         for (int i=0; i<calif.length; i++) {
            cobayos[ i ].setFa( calif[ i ] );
         }

      // Avisa a quien este esperando
         ThreadGroup mi_thread_group = Thread.currentThread().getThreadGroup();
         synchronized ( mi_thread_group ) {
            mi_thread_group.notifyAll();
         }
      }
   }

