
// Parte del paquete de GP
   package GP;

/**
 * Fabrica de instancias de clase <B>Funcional</B>.<BR>
 *
 * @author Antonio Pena
 * @version jul-1997
 */
   public class FuncionalFactory extends Object {

   /**
    * Un arreglo que contiene las clases por numero.<BR> */
      protected Class[]   aclass;


   /**
    * Constructor.<BR>
    *
    * @param funcionales
    *    Es un arreglo de objetos <B>String</B> que
    *    contiene los nombres de las clases funcionales
    *    a generar.<BR>
    *
    * @exception ClassNotFoundException
    *    Cuando no es encontrada una de las clases
    *    enumeradas en el arreglo <B>clases<B>.<BR> */
      public FuncionalFactory( String[] clases )
       throws ClassNotFoundException
      {

      // Inicia el arreglo
         aclass = new Class[ clases.length ];

      // Agrega al arreglo y hash de clases cada una de ellas
         for (int i=0; i<clases.length; i++) {
            Class cls = Class.forName( clases[ i ] );
            aclass[ i ] = cls;
         }
      }


   /**
    * Devuelve el numero de clases registradas.<BR> */
      public int n() { return aclass.length; }
    

   /**
    * Permite instanciar un objeto de la n-esima clase registrada.<BR>
    *
    * @return <B>null</B> si ocurre algun error al instanciar la clase.<BR> */
      public Funcional nuevo( int n ) {

      // Crea una nueva instancia de esa clase
         try {
            return (Funcional) aclass[ n - 1 ].newInstance();
         } catch (IllegalAccessException e) {
            return null;
         } catch (InstantiationException e) {
            return null;
         }
      }


   /**
    * Crea una representacion <B>String</B> del
    * conjunto de funcionales.<BR> */
      public String toString() {
         String str = new String( "Funcionales: { " );
         
         for (int i=1; i<=aclass.length; i++) {
            str = str.concat( aclass[ i-1 ].getName() );
            if (i < aclass.length)
               str = str.concat( ", " );
         }
         str = str.concat( " }" );

         return str.toString();
      }
   }

