
// Parte del paquete de GP
   package GP;

/**
 * Esta clase provee un generador de numeros aleatorios.<BR>
 *
 * @author Antonio Pena
 * @version jun-1997
 */
  public class Random {

  // El ganerador
     static private java.util.Random rnd_gen;


  /**
   * Alguno de los tipos del metodo <B>init</B> debe invocarse
   * antes de solicitar numeros aleatorios del generador.<BR> */
     public static void init() { rnd_gen = new java.util.Random(); }


  /**
   * Alguno de los tipos del metodo <B>init</B> debe invocarse
   * antes de solicitar numeros aleatorios del generador.<BR>
   *
   * @param seed
   *    Es la semilla inicial del generador.<BR> */
     public static void init( int seed ) {
        rnd_gen = new java.util.Random( seed );
     }


 /**
  * Obtiene un entero del generador.<BR>
  *
  * @param range
  *    El rango deseado para el entero <B>[1, range]</B>.<BR>
  *
  * @return Devuelve un entero en el rango <B>[1, range]</B>.<BR> */
    public synchronized static int randomInt( int range ) {
       return (int) ( Random.rnd_gen.nextFloat() * range ) + 1;
    }


 /**
  * Obtiene un flotante del generador.<BR>
  *
  * @return Devuelve un entero en el rango <B>[0, 1]</B>.<BR> */
    public synchronized static float randomFloat() {
       return Random.rnd_gen.nextFloat();
    }
  }

