
// Parte del paquete de GP
   package GP;

// Uso de vectores por aqui
   import java.util.Vector;

/**
 * La clase <B>Sort</B> implementa algoritmos de ordenamiento
 * que actuan sobre los elementos de clases contenedoras como
 * <B>Vector</B>.<BR>
 *
 * @author Antonio Pena
 * @version jun-1997
 */
   public class Sort {

   /**
    * Este metodo de clase implementa el algoritmo
    * de QuickSort sobre los elementos de un <B>Vector</B>.<BR>
    *
    * @param v
    *    Todos los elementos del vector deben descender,
    *    implementar la interfaz <B>Ordenable</B>.<BR> */
      public static void vQSort( Vector v ) {

      // Elementos en el vector
         int v_elem = v.size();

      // Llama a la seccion recursiva vQS
         Sort.vQS( v, 0, v_elem-1 );
      }


   // Ordenado de un rango de vector
      private static void vQS( Vector v, int lo, int hi ) {

      // Los limites originales del rango
         int lo_orig = lo;
         int hi_orig = hi;


      // Ordena solo los rangos reales
         if (hi_orig > lo_orig) {

         // Selecciona el pivote como el punto medio del rango
            int mid_p = (lo_orig + hi_orig) / 2;
            Ordenable mid = (Ordenable) v.elementAt( mid_p );

         // Recorre el vector hasta que los indices se cruzen
            while ( lo <= hi ) {

            // Encuentra el elemento mas izquierdo que sea igual o mayor a 'mid'
               while ( ( lo < hi_orig )
                   && ( ((Ordenable) v.elementAt(lo)).orden(mid) < 0 ) )   ++lo;

            // Encuentra el elemento mas derecho que sea menor o igual a 'mid'
               while ( ( hi > lo_orig )
                   && ( ((Ordenable) v.elementAt(hi)).orden(mid) > 0 ) )   --hi;


            // Si los indices no se han cruzado, intercambia los elementos
               if ( lo <= hi ) {
                  Object o = v.elementAt( lo );
                  v.setElementAt( v.elementAt( hi ), lo );
                  v.setElementAt( o, hi );
                  ++lo;   --hi;
               }
            }

         // Si el indice derecho no ha llegado a la izquierda,
         // hay que ordenar la seccion izquierda.
            if ( lo_orig < hi )   vQS( v, lo_orig, hi );

         // Si el indice izquierdo no ha llegado a la derecha,
         // hay que ordenar la seccion derecha.
            if ( lo < hi_orig )   vQS( v, lo, hi_orig );
         }
      }
   }

