
// Las clases del paquete de GP
   import GP.*;

/**
 * La clase <B>StartHanoi</B> en una aplicacion Java
 * que ejecuta una corrida del problema de torres de
 * Hanoi bajo el conjunto de parametros especificados
 * abajo.<BR>
 *
 * @author Antonio Pena
 * @version jun-1997
 */
   public class StartHanoi {

   // La especificacion de la especie para la poblacion
      static Especie    especie;


   // Las clases de funcionales terminales del arbol de programa
      static String[] t_rpb = { "hnUltimo", "hnMinimo" };

   // Las clases de funcionales no terminales del arbol de programa
      static String[] nt_rpb = { "hnMueve", "hnMenor", "hnMayor",
                                 "hnPIzq",  "hnPDer" };


   // Fija los parametros de inicio
      public static int        seed = 1;
      public static int        nInd = 500;
      public static int        deep = 5;
      public static int    max_deep = 10;
      public static boolean balance = true;
      public static String   metodo = "HRAMP";

   // Fija los parametros de la corrida del motor 
      public static int        nGen = 100;
      public static int      g_size = 1;
      public static int   max_train = 16;
      public static float    pcruza = (float)0.8;
      public static float  mutacion = (float)0.2;
      public static float  reproduc = (float)0.0;

   /**
    * El metodo <B>main()</B> es el procedimiento principal de la
    * aplicacion.<BR>
    *
    * @exception ClassNotFoundException
    *    Se genera si alguna de las clases de funcionales del
    *    usuario o, su clase entrenadora no es encontrada.<BR>
    * @exception InstantiationException
    *    Se genera si alguna de las clases de funcionales del
    *    usuario o, su clase entrenadora no puede ser instanciada.<BR>
    * @exception IllegalAccessException
    *    Se genera en el caso de una restriccion de acceso a alguna
    *    de las clases del usuario.<BR> */
      public static void main( String[] argv )
       throws ClassNotFoundException,
              InstantiationException,
              IllegalAccessException
      {

      // Inicia el entrenador del problema
         hnTrainer.init();

      // Crea la especificacion de la especie
         especie = new Especie( "Hanoi",
                                balance, deep, max_deep,
                                t_rpb, nt_rpb );

      // Elije cualquier semilla para el generador de numeros aleatorios
         seed = (int)(Math.random() * 2147483647);
         System.out.println("Run seed: " + seed);

      // Crea el motor 
         Motor m = new Motor( seed, nInd, especie, metodo );

      // Echa a andar la corrida
         m.run( nGen, g_size,
                pcruza, mutacion, reproduc,
                "hnTrainer", max_train );
      }
   }

