#! /usr/bin/perl

#
# Script para producir codigo en java
#
# Antonio Pena  (jul-1997)
#

# Lee de STDIN
  while (chop( $line = <STDIN> )) {

  # Que sea un caso para las torres de Hanoi
    next   unless ($line =~ m/caso\s+\d+:\s+(\S+)\s+(\S+)\s+(\d)\s+(\d+).*$/);

  # Obten la configuracion del tablero
    $org = $1;   $obj = $2;   $ult = $3;   $max = $4;

  # Guardale
    push @casos, "${org}_${obj}_${ult}_${max}";
  }


# Escupe declaraciones en Java
  print <<EODec;
         String[][]    org, obj;
 
      // Crea el arreglo de ambientes
         casos = 100;
         ambientes = new hnAmbiente[ casos ];
 
EODec


# Para todos los casos registrados
  foreach $caso (@casos) {
    ($org, $obj, $ult, $max) = split('_', $caso);

  # Escupe el origen
    &Escupe("org", $org);

  # Escupe el objetivo
    &Escupe("obj", $obj);

  # Haz la creacion del ambiente
    printf STDOUT "         ambientes[ %d ] = new hnAmbiente( org, obj );\n",
                                       $casos;
    printf STDOUT "         ambientes[ %d ].ultimo = ", $casos;
    if ( $ult > 0 ) {
      printf STDOUT "ambientes[ %d ].origen.postes[ %d ];\n", $casos, $ult-1;
    } else {
      printf STDOUT "null;\n";
    }
    printf STDOUT "         ambientes[ %d ].max = $max;\n", $casos;
    $casos++;
  }


# Genera ls declaracion de un tablero
  sub Escupe {
    my ($nom, $cfg) = @_;

    @postes = split('\|', $cfg, 3);

    # Declara el origen de acuerdo al numero de postes
      print  STDOUT "\n";
      printf STDOUT "         %s = new String[ %d ][];\n", $nom, $#postes+1;

    # Declara el numero de simbolos en cada poste
      for ($i=0; $i<=$#postes; $i++) {
        printf STDOUT "         %s[ $i ] = new String[ %d ];\n", $nom,
                                     length($postes[ $i ]);

      # Asigna los simbolos de los postes
        for ($j=0; $j<length($postes[ $i ]); $j++) {
          printf STDOUT "         %s[ $i ][ $j ] = \"%s\";\n", $nom,
                        substr($postes[ $i ], $j, 1);
        }
      }
    }

