#! /usr/bin/perl

#
# Genera casos aleatorios para un evaluador de
# torres de Hanoi en GP
#
# Antonio Pena  (jul-1997)
#

# El numero maximo de piezas a utilizar
  $max_piezas = $ARGV[ $[ ];

# El numero maximo de jugadas a transformar
  $max_jugadas = $ARGV[ $[+1 ];

# El numero de casos a generar
  $n_casos = $ARGV[ $[+2 ];

# Esta todo ahi?
  die "hCasos.pl <PIEZAS> <JUGADAS> <CASOS>"
    if ($max_piezas == 0 or $max_jugadas == 0 or $n_casos == 0);


# Fabrica los casos solicitados
  while ($generados < $n_casos) {

  # Crea un nuevo tablero con un numero de piezas al azar
    $n_piezas = 1 + int rand( $max_piezas );
    $tabRef = &nvoTablero( $n_piezas );
    print "Tablero: $n_piezas -> " . &toString( $tabRef ) . "\n";
    next;


  # Juega este tablero un numero aleatorio de veces
    $n_jugadas = int rand( $max_jugadas + 1 );
    $n_jugadas = 2**$n_piezas - 1   if ($n_jugadas > 2**$n_piezas - 1);


    # Juega el tablero un numero de jugadas
      $tiradas = 0;
      $s_org = &Juega( $s_obj, $n_jugadas );
      ($s_org, $s_ult) = split(' ', $s_org);
      # print STDERR "De: <$s_org>, A: <$s_obj> $s_ult\n";

    # El caso no debe existir
      next   if (defined $casos{ "$s_org^$s_obj^$s_ult" });
      $casos{ "$s_org^$s_obj^$s_ult" } = 1;
      ++$generados;

    # Escupelo
      printf STDOUT "caso %5d: %-15s %-15s $s_ult $tiradas\n",
                     $generados, $s_org, $s_obj;
  }


# Juega un tablero un numero de veces
  sub Juega {
    my ($tab, $jug) = @_;
    my (@pst) = split('\|', $tab);
    # print STDERR "Postes: $jug $tab <$pst[0]> <$pst[1]> <$pst[2]>\n";

  # Orale, las tiradas
    my (@pos) = ();
    push @pos, $tab;
    my (%pos);
    my ($movida) = -1;
    $tiradas = 0;
    while ($tiradas < $jug) {

    # Un poste origen
      $a_mover = &origen( $pst[0], $pst[1], $pst[2], $movida );
      last   if ( $a_mover < 0 );

    # Un poste destino
      $a_poner = &destino( \@pst, $a_mover );
      # print STDERR
      #   "A mover: <$pst[0]> <$pst[1]> <$pst[2]> -> $a_mover $a_poner\n";
      last   if ( $a_poner < 0 );

    # Muevelo, muevelo !
      $get = chop( $pst[ $a_mover ] );
      $pst[ $a_poner ] .= $get;

      if (! defined( $pos{ "$pst[ 0 ]|$pst[ 1 ]|$pst[ 2 ]" } )) {
         $pos{ "$pst[ 0 ]|$pst[ 1 ]|$pst[ 2 ]" } = 1;
         push @pos, "$pst[ 0 ]|$pst[ 1 ]|$pst[ 2 ]";
      } else { last }
      $movida = $a_poner;

      ++$tiradas;
    }
    $a_mover = &origen( $pst[0], $pst[1], $pst[2], $movida );

    return sprintf "$pst[0]|$pst[1]|$pst[2] %d", $a_mover+1;
  }


# Escoge un poste a modificar
  sub origen {
    my ($uno, $dos, $trs, $ig) = @_;
    my ($bno) = "ZZZZZZZZZZZZZZZZZ";
    my ($sel) = $ig+1;  $sel = 0   if ($sel > 2);

    if ( $ig != 0  and  $uno ne ""  and  substr($uno, -1) lt $bno ) {
      $bno = substr($uno, -1);   $sel = 0;
    }
    if ( $ig != 1  and  $dos ne ""  and  substr($dos, -1) lt $bno ) {
      $bno = substr($dos, -1);   $sel = 1;
    }
    if ( $ig != 2  and  $trs ne ""  and  substr($trs, -1) lt $bno ) {
      $bno = substr($trs, -1);   $sel = 2;
    }

    return $sel;
  }


# Escoge un poste destino
  sub destino {
    my ($pref, $org) = @_;
    my ($sel) = -1;

    my ($fch) = substr(@{$pref}[ $org ], -1);
    for ($i=1; $i<3; $i++) {
      --$org;   $org = 2   if ( $org < 0 );
      if ( @{$pref}[ $org ] eq ""  or
           substr(@{$pref}[ $org ], -1) gt $fch) { $sel = $org; last; }
    }

    return $sel;
  }


# Crea un nuevo tablero al azar
  sub nvoTablero {
    my($pz) = @_;

  # Acomoda las piezas en el tablero destino
    undef my(@tabl);
    my($i, $poste);
    for ($i=0; $i<$pz; $i++) {

    # Elije un poste al azar para esta pieza
      $poste = int rand(3);

    # Echala en el poste
      push @{$tabl[ $poste ]}, pack("C", $i+65);
    }

  # Devuelveles una referencia
    return \@tabl;
  }


# Convierte un tablero a cadena de caracteres
  sub toString {
    my($tRef) = @_;

    return    join("", @{$$tRef[0]})
      . "|" . join("", @{$$tRef[1]})
      . "|" . join("", @{$$tRef[2]});
  }

