
/**
 * El ambiente de ejecucion para el problema de torres de Hanoi.<BR>
 *
 * Contiene un tablero origen y un poste objetivo,
 * asi como una cuenta del minimo numero de movimientos
 * requeridos para la solucion.<BR>
 *
 * @author Antonio Pena
 * @version jul-1997
 */
   public class hnAmbiente extends Object {

   // El tablero origen
      hnTablero    origen;

   // El poste objetivo
      hnPoste      objetivo = null;

   // El minimo numero de movidas para ir de origen a objetivo
      int          mov_min = 0;


   /**
    * Un constructor vacio.<BR> */
      public hnAmbiente() { }

   /**
    * Constructor.<BR>
    *
    * @param org
    *    Es un arreglo bidimensional de cadenas que representa
    *    la configuracion inicial.<BR>
    * @param obj
    *    Es un arreglo bidimensional de cadenas que representa
    *    la configuracion objetivo.<BR> */
      public hnAmbiente( hnTablero org, hnPoste obj, int movs ) {
         origen   = org;
         objetivo = obj;
         mov_min  = movs;
      }

   /**
    * Produce una copia del ambiente.<BR> */
      public Object clone() {
         hnAmbiente clon = new hnAmbiente();

      // Duplica el origen y el objetivo
         clon.origen   = (hnTablero) this.origen.clone();
         clon.objetivo = clon.origen.postes[
                            this.origen.idxPoste( this.objetivo ) ];;

      // El numero de movidas de solucion
         clon.mov_min = this.mov_min;

         return clon;
      }


   /**
    * Determina si ya se logro el tablero objetivo.<BR> */
      public boolean ya() {
         if ( this.origen.nPiezas() == this.objetivo.nPiezas() )
            return true;
         else
            return false;
      }

   /**
    * Regresa una representacion <B>String</B> del ambiente.<BR> */
      public String toString() {
         String str = new String( "\nAmbiente:\n" );

      // Concatena los tableros origen y objetivo
         str = str.concat( origen.toString() + "\n" );
         str = str.concat( origen.idxPoste( objetivo ) + "\n" );

         return str;
      }
   }

