
// Las clases del paquete de GP
   import GP.*;

/**
 * Este funcional recibe dos postes de tablero a traves de
 * sus operandos y el poste que tiene la pieza de mayor diametro.<BR>
 *
 * @author Antonio Pena
 * @version jul-1997
 */
   public class hnMayor extends hnNodo {

   // Constructor
      public hnMayor () { operandos = new Funcional[ 2 ]; }

   // Clongale
      public Object clone () {
         hnMayor clon = new hnMayor();
         clon.operandos[ 0 ] = (Funcional) this.operandos[ 0 ].clone();
         clon.operandos[ 1 ] = (Funcional) this.operandos[ 1 ].clone();

         return clon;
      }


   /**
    * Devuelve una referencia al poste del tablero que
    * contiene la pieza mayor.<BR>
    *
    * @param ambiente
    *    Interpreta el parametro como una instancia de la
    *    clase <B>hnAmbiente</B>.<BR> */
      public final hnPoste eval( Individuo sujeto, Object ambiente ) {

      // Obten los dos postes a comparar
         hnPoste uno = ((hnNodo) operandos[ 0 ]).eval( sujeto, ambiente );
         hnPoste dos = ((hnNodo) operandos[ 1 ]).eval( sujeto, ambiente );

      // Las piezas
         hnPieza p_uno = uno == null ? null : uno.piezaSup();
         hnPieza p_dos = dos == null ? null : dos.piezaSup();

      // Triviales
         if ( p_uno == null && p_dos == null )   return null;
         if ( p_uno != null && p_dos == null )   return uno;
         if ( p_uno == null && p_dos != null )   return dos;

      // La pieza menor
         if ( p_uno.compareTo( p_dos ) > 0 )     return uno;
         else                                    return dos;
      }

   /**
    * Devuelve una representacion <B>String</B> del funcional.<BR>
    *
    * @return "(Mayor p1.<B>toString()</B>, p2.<B>toString()</B>)".<BR> */
      public final String toString() {
         return "(Mayor " + operandos[ 0 ].toString() +
                     ", " + operandos[ 1 ].toString() + ")";
      }
   }

