
// Las clases del paquete de GP
   import GP.*;

/**
 * Este funcional mueve una ficha en el tablero de torres de Hanoi.<BR>
 *
 * @author Antonio Pena
 * @version jul-1997
 */
   public class hnMueve extends hnNodo {

   // Constructor
      public hnMueve () { this.operandos = new Funcional[ 2 ]; }

   // Clongale
      public Object clone () {
         hnMueve clon = new hnMueve();
         clon.operandos[ 0 ] = (Funcional) this.operandos[ 0 ].clone();
         clon.operandos[ 1 ] = (Funcional) this.operandos[ 1 ].clone();

         return clon;
      }


   /**
    * Mueve la ficha en el poste identificado por su primer operando
    * al poste identificado por su segundo operando y devuelve una
    * referencia al poste destino.
    *
    * Si el tablero origen ha alcanzado el objetivo, la
    * funcion no hace nada y devuelve <B>null</B>.
    *
    * Si cualquiera de los operandos es nulo, el poste origen
    * no contiene piezas, o el poste destino contiene una
    * pieza menor a la pieza a mover, la funcion no hace
    * nada y devuelve <B>null</B>.
    *
    * @param ambiente
    *    Interpreta el parametro como una instancia de la
    *    clase <B>hnAmbiente</B>.<BR> */
      public final hnPoste eval( Individuo sujeto, Object ambiente ) {

      // Si ya logramos el objetivo, haz mutis por la izquierda
         if ( ((hnAmbiente) ambiente).ya() )   return null;

      // Los postes fuente y destino
         hnPoste fuente  = ((hnNodo) operandos[ 0 ]).eval( sujeto, ambiente );
         hnPoste destino = ((hnNodo) operandos[ 1 ]).eval( sujeto, ambiente );

      // Bien, todo parece estar listo para la movida !
         return ((hnAmbiente) ambiente).origen.muevePieza( fuente, destino );
      }


   /**
    * Devuelve una representacion <B>String</B> del funcional.<BR>
    *
    * @return "(Mueve p1.<B>toString()</B> )".<BR> */
      public final String toString() {
         return "(Mueve " + operandos[ 0 ].toString() + ", "
                          + operandos[ 1 ].toString() + ")";
      }
   }

