
// Las clases del paquete de GP
   import GP.*;

/**
 * Este funcional devuelve una referencia al poste a la izquierda
 * del poste que recibe al evaluar su operando.<BR>
 *
 * @author Antonio Pena
 * @version jul-1997
 */
   public class hnPIzq extends hnNodo {


   // Constructor
      public hnPIzq () { this.operandos = new Funcional[ 1 ]; }

   // Clongale
      public Object clone () {
         hnPIzq clon = new hnPIzq();
         clon.operandos[ 0 ] = (Funcional) this.operandos[ 0 ].clone();

         return clon;
      }

   /**
    * Devuelve una referencia al poste a la izquierda del
    * poste que recibe de su operando.<BR>
    *
    * Devuelve <B>null</B> si su operando evalua a 'null'.<BR>
    *
    * @param ambiente
    *    Interpreta el parametro como una instancia de la
    *    clase <B>hnAmbiente</B>.<BR> */
      public final hnPoste eval( Individuo sujeto, Object ambiente ) {

      // Obten el poste a evitar de nuestro parametro
         hnPoste este = ((hnNodo) operandos[ 0 ]).eval( sujeto, ambiente );
         if (este == null)   return null;

      // Que numero de poste es?
         int n_poste = ((hnAmbiente) ambiente).origen.idxPoste( este );
         if ( n_poste < 0 )   return null;

      // Encuentra el poste a la izquierda
         --n_poste;   n_poste = n_poste < 0 ? 2 : n_poste;


         return ((hnAmbiente) ambiente).origen.postes[ n_poste ];
      }


   /**
    * Devuelve una representacion <B>String</B> del funcional.<BR>
    *
    * @return "(PIzq p1.<B>toString()</B> )".<BR> */
      public final String toString() {
         return "(PIzq " + operandos[ 0 ].toString() + ")";
      }
   }

