
/**
 * Implementa la representacion de una pieza de tablero
 * en el problema de torres de Hanoi.<BR>
 *
 * @author Antonio Pena
 * @version jul-1997
 */
   public class hnPieza extends Object {

   /**
    * Es el identificador de una pieza y determina su diametro,
    * considerando que la pieza de menor diametro es 'A' y la de
    * mayor diametro es 'Z'.<BR> */
      char    id = ' ';


   /**
    * Constructor.<BR>
    *
    * @param identificador
    *    Es el identificador de la pieza que se desea crear.<BR> */
      public hnPieza( char identificador ) { id = identificador; }

   /**
    * Determina si dos piezas tienen el mismo identificador.<BR>
    *
    * @param cmp
    *    Es la pieza contra la que se compara.<BR> */
      public boolean equals( hnPieza cmp ) {
         return id == cmp.id;
      }

   /**
    * Compara los identificadores de dos piezas.<BR>
    *
    * @param cmp
    *    Es la pieza contra la que se compara.<BR>
    *
    * @returns <B>-n</B> si <B>this</B> <  <B>cmp</B><BR>
    *           <B>0</B> si <B>this</B> == <B>cmp</B><BR>
    *           <B>0</B> si <B>this</B> >  <B>cmp</B><BR> */
      public int compareTo( hnPieza cmp ) {
         return id - cmp.id;
      }

   /**
    * Regresa una representacion <B>String</B> de la pieza.<BR> */
      public String toString() {
         char[] ch_arr = new char[1];

      // El identificador de la pieza en el arreglo
         ch_arr[ 0 ] = id;

      // Regresa una cadena
         return new String( ch_arr );
      }
   }

